#install.packages("tidyverse")
#install.packages("gridExtra")
#install.packages("reshape2")
library(tidyverse)
library(gridExtra)
library(reshape2)


n=20
N=10000
I=1:N
est01=est_0=est_1=est15=est2=est3=SE01=SE_0=SE_1=SE15=SE2=SE3=numeric(N)
for(n in 1:N){
  alpha=-1
  Sig=(1:n)^alpha
  set.seed(1)
  y=rnorm(n,mean=1,sd=sqrt(Sig))
  est01[n]=sum(y/Sig)/sum(1/Sig)
  SE01[n]=sqrt(1/sum(1/Sig))
 
  alpha=0
  Sig=(1:n)^alpha
  set.seed(1)
  y=rnorm(n,mean=1,sd=sqrt(Sig))
  est_0[n]=sum(y/Sig)/sum(1/Sig)
  SE_0[n]=sqrt(1/sum(1/Sig))
  
  alpha=1
  Sig=(1:n)^alpha
  set.seed(1)
  y=rnorm(n,mean=1,sd=sqrt(Sig))
  est_1[n]=sum(y/Sig)/sum(1/Sig)
  SE_1[n]=sqrt(1/sum(1/Sig))
  
  
  alpha=1.5
  Sig=(1:n)^alpha
  set.seed(1)
  y=rnorm(n,mean=1,sd=sqrt(Sig))
  est15[n]=sum(y/Sig)/sum(1/Sig)
  SE15[n]=sqrt(1/sum(1/Sig))
  
  alpha=2
  Sig=(1:n)^alpha
  set.seed(1)
  y=rnorm(n,mean=1,sd=sqrt(Sig))
  est2[n]=sum(y/Sig)/sum(1/Sig)
  SE2[n]=sqrt(1/sum(1/Sig))
  
  alpha=3
  Sig=(1:n)^alpha
  set.seed(1)
  y=rnorm(n,mean=1,sd=sqrt(Sig))
  est3[n]=sum(y/Sig)/sum(1/Sig)
  SE3[n]=sqrt(1/sum(1/Sig))
  
}

df=data.frame("index"=I, est15, est2, est3)
dat_melt=melt(df, id.vars="index", variable.name = "est")

plot_inc=ggplot(dat_melt, aes(x=index, y=value, color=est))+
    geom_hline(yintercept = 1,linetype="dashed")+
  geom_line()+
  scale_color_hue(name="cases(inconsistent)",labels=c(est15=expression(paste(alpha == 1.5)),
                                        est2=expression(paste(alpha == 2)),
                                        est3=expression(paste(alpha == 3))))+
  labs(x="n (the number of studies)",y="Estimate for the true value = 1")+
  scale_y_continuous(limits = c(0.3,1.3))+
  theme(legend.position = c(0.9, 0.3),
        legend.justification = c("right", "top"),
        legend.background = element_rect(fill = "white", colour = "black"),
        legend.text = element_text(size = 11),
        legend.title = element_text(size = 11),
        legend.key.size = unit(0.8, 'cm'),
        legend.text.align = 0,
        legend.spacing.x=unit(0.7,"cm"),
        legend.margin = margin(5, 15, 5, 10)
        )+
  guides(color=guide_legend(nrow=1))

plot_inc
  
  
  
  
  df=data.frame("index"=I, est01, est_0, est_1)
  dat_melt=melt(df, id.vars="index", variable.name = "est")
  

plot_con=ggplot(dat_melt, aes(x=index, y=value, color=est))+
    geom_hline(yintercept = 1,linetype="dashed")+
    geom_line()+
    scale_color_hue(name="cases(consistent)",labels=c(est01=expression(paste(alpha == -1)),
                                          est_0=expression(paste(alpha == 0)),
                                          est_1=expression(paste(alpha == 1))
                                          )
                    )+
    labs(x="n (the number of studies)",y="Estimate for the true value = 1")+
    scale_y_continuous(limits = c(0.9,1.4))+
    theme(legend.position = c(0.9, 0.97),
          legend.justification = c("right", "top"),
          legend.background = element_rect(fill = "white", colour = "black"),
          legend.text = element_text(size = 11),
          legend.title = element_text(size = 11),
          legend.key.size = unit(0.8, 'cm'),
          legend.text.align = 0,
          legend.spacing.x=unit(0.7,"cm"),
          legend.margin = margin(5, 15, 5, 10)
    ) +
  guides(color=guide_legend(nrow=1))
plot_con 

simu_plot=grid.arrange(plot_con,plot_inc)
simu_plot
